/*************************************************************************
*  Copyright (C) 2004 by Olivier Galizzi                                 *
*  olivier.galizzi@imag.fr                                               *
*                                                                        *
*  This program is free software; it is licensed under the terms of the  *
*  GNU General Public License v2 or later. See file LICENSE for details. *
*************************************************************************/

#pragma once

#include<yade/core/InteractionPhysics.hpp>

class SpringPhysics : public InteractionPhysics
{
	public :
		Real		 stiffness
				,damping
				,initialLength;

		SpringPhysics();
		virtual ~SpringPhysics();

	REGISTER_ATTRIBUTES(InteractionPhysics,(stiffness)(damping)(initialLength));
	REGISTER_CLASS_NAME(SpringPhysics);
	REGISTER_BASE_CLASS_NAME(InteractionPhysics);

	REGISTER_CLASS_INDEX(SpringPhysics,InteractionPhysics);
};

REGISTER_SERIALIZABLE(SpringPhysics);


